

#define MAXB 100
#define MAXS 30
#define MAXPL 12

#define BRON     0x10000
#define MODIFIED 0x20000 
#define OFFBOARD 0x40000
#define FFILLED  0x80000 
#define PISHIFT 0
#define PIMASK 0xff
#define PLSHIFT 8
#define PLMASK 0xf00
#define PPSHIFT 12
#define PPMASK 0xf000

#define  NP(x,y)  (  brd[x][y]             & 0xff)
#define  PL(x,y)  (( brd[x][y] >> PLSHIFT) & 0x0f)
#define tNP(x,y)  ( tbrd[x][y]             & 0xff)
#define tPL(x,y)  ((tbrd[x][y] >> PLSHIFT) & 0x0f)
#define NPP(x,y)  (( brd[x][y] >> PPSHIFT) & 0x0f)


#define SETPIECES(x,y,p)  \
	(brd[x][y] = (brd[x][y] & ~PIMASK) | ((p) << PISHIFT))
#define SETPLAYER(x,y,pl)  \
	(brd[x][y] = (brd[x][y] & ~PLMASK) | ((pl) << PLSHIFT))
#define SETNPP(x,y,v)  \
	(brd[x][y] = (brd[x][y] & ~PPMASK) | (v << PPSHIFT))
#define SETMODIFIED(x,y) \
	(brd[x][y] |=  MODIFIED)
#define CLRMODIFIED(x,y) \
	(brd[x][y] &= ~MODIFIED)
#define MAKEBRON(x,y) (brd[x][y] = (brd [x][y] & PLMASK) | BRON)
#define SETBRON(x,y) (brd[x][y] |= BRON)
#define MAKEOFFBOARD(x,y) (brd[x][y] = OFFBOARD)
#define SETONBOARD(x,y) (brd[x][y] &= ~OFFBOARD)
#define MAKEKRATER(x,y) MAKEOFFBOARD(x,y)
#define MAKEEMPTY(x,y) (brd[x][y] = 0)

#define SETPLPI(x,y,p,n)  SETPIECES (x,y,n),SETPLAYER(x,y,p)


#define ISBRON(x,y) ((brd[x][y] & BRON) != 0)
#define ISOFFBOARD(x,y) ((brd[x][y] & OFFBOARD) != 0)

#define ISBOARD(x,y) (!ISOFFBOARD (x,y) && !ISBRON (x,y))

#define ISEMPTY(x,y) (NP(x,y) == 0)
#define ISMODIFIED(x,y) ((brd[x][y] & MODIFIED) != 0)

#define ISFILLED(x,y)  (brd[x][y]  &  FFILLED)
#define SETFILLED(x,y) (brd[x][y] |=  FFILLED)
#define CLRFILLED(x,y) (brd[x][y] &= ~FFILLED)

#define SECTX(i,j) (hdx + i * 3 + j)
#define SECTY(i,j) (hdy - i     + j * 2)

#define BRD ((void *)brd)
#define BRD_SIZE (MAXB*MAXB*sizeof (int))

#define ever ;;

#ifndef min
#define min(a,b) ((a<b)?a:b)
#endif
#ifndef max 
#define max(a,b) ((a<b)?b:a)
#endif

#define ALLSECTORS(i,j) \
	j=0;j < MAXS;j++) \
            for (i = 0;(i < MAXS);i++) \
		if (sectors[i][j]

#define ALLHEXS(x,y) \
	x=0;x< MAXB;x++)  \
		for (y=0;y<MAXB;y++) \
			if (ISBOARD (x,y)

#define ALLDIRS(k) \
	k = 0; k < 7; k++


/* One letter codes in output of getboard, update_user, dosave: */
#define EMPTY	'e'
#define CRATER	'c'
#define SOURCE	's'
#define PLAYER	'p'

extern int brd[MAXB][MAXB];
extern int dirsx[],dirsy[];
extern int sectors[MAXS][MAXS];

extern int pl;
extern int nplay;
extern int sdx,sdy;
extern int hdx,hdy;

void doplof (int x,int y);
void checkplof (int p);
void dobron (int p);
int verify_move (int x,int y,int n,int d);
void domove (int x,int y,int n,int d);
void init_moves (int pl);
void doload (char *name);
void dosave (char *name);
int hassunk (int i,int j);
int hasmodified (int i,int j);
void clearmodified (int i,int j);
int checkscore (void);
void initboard (int np,int sz,FILE *fp);
int convert(int x0,int y0,int x1,int y1,int *nn,int *dd);
