#include <errno.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

struct ral_fd {
  struct ral_fd *next;
  int fd;
  char *buf;
  int tail,n;
  int eof;
};

struct ral_fd *firstfd;

struct ral_fd *findfd (int fd)
{
  struct ral_fd *t;

  for (t = firstfd;t != NULL;t=t->next)
    if (t->fd == fd) return t;

  t = malloc (sizeof (struct ral_fd));
  t->fd = fd;
  t->buf = malloc (1000);
  t->tail = t->n = 0;
  t->eof = 0;
  t->next = firstfd;
  firstfd = t;
  return t;
}

char *read_a_line (int fd)
{
  int i,tt,n;
  struct ral_fd *fdp;

  fdp = findfd (fd);
  for (i=fdp->tail;i<fdp->n;i++)
    if (fdp->buf[i] == '\n') {
      fdp->buf[i] = '\0';
      tt = fdp->tail;
      fdp->tail = i+1; 
      return (fdp->buf+tt);
    }
  for (i=0;i< fdp->n-fdp->tail;i++)
    fdp->buf[i] = fdp->buf[fdp->tail+i];
  fdp->n -= fdp->tail;
  fdp->tail = 0;
  errno = 0;
  n = read (fdp->fd,fdp->buf+fdp->n,1000-fdp->n);
  if ((n < 0) && (errno == EAGAIN))
    return (NULL);
  if (n == 0) {
    fdp->eof = 1;
    return (NULL);
  }

  fdp->n += n;
  if (fdp->n == 0)
    return NULL;

  for (i=fdp->tail;i<fdp->n;i++)
    if (fdp->buf[i] == '\n') {
      fdp->buf[i] = '\0';
      tt = fdp->tail;
      fdp->tail = i+1; 
      return (fdp->buf+tt);
    }
  return (NULL);
}

int more_input_available (int fd)
{
  struct ral_fd *fdp;

  fdp = findfd (fd);
  return (fdp->tail != fdp->n);
}

int ral_eof (int fd)
{
  struct ral_fd *fdp;

  fdp = findfd (fd);
  return fdp->eof;
}

void ral_close (int fd)
{
  struct ral_fd *fdp;

  fdp = findfd (fd);
  fdp->n  = fdp->eof = fdp->tail = 0;
}
