
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <signal.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <errno.h>

#include "atlantis.h"
#include "serve.h"

#include "commands.h"
#define NEED_TABLE
#include "commands.h"
#include "ral.h"


extern int major,minor,subminor;

struct clientstr clients[MAXCLIENTS];


int curclient;
struct clientstr *client;

struct clientstr *player[MAXPL];
void newclient (struct clientstr *client,int newplayer, FILE *newplayerFILE);


extern const char * myname;

/* Things for the select system call. */
int numfds;
fd_set allfds;


void cprintf (char *str,...)
{
  va_list v;

  va_start (v,str);
  vfprintf (curfp, str, v);
  fflush  (curfp);
  va_end (v);
}

void cbprintf (char *str,...)
{
  va_list v;

  va_start (v,str);
  vfprintf (curfp, str, v);
  va_end (v);
}

	
void pprintf (int pln,char *str,...)
{
  va_list v;

  va_start (v,str);
  vfprintf (player[pln]->fp, str, v);
  fflush  (player[pln]->fp);
  va_end (v);
}

void aprintf (char *str,...)
{
  va_list v;
  int i;

  va_start (v, str);
  for (i=0;i<MAXCLIENTS;i++) {
    if (clients[i].st != NO_CLIENT) {
      vfprintf (clients[i].fp,str,v);
      fflush  (clients[i].fp);
    }
  }
  va_end (v);
}


void abprintf (char *str,...)
{
  va_list v;
  int i;

  va_start (v, str);
  for (i=0;i<MAXCLIENTS;i++) {
    if (clients[i].st != NO_CLIENT)
      vfprintf (clients[i].fp, str, v);
  }
  va_end (v);
}


int serve (int socket)
{
  fd_set readfds;
  struct sockaddr remoteaddr;
  int sa, ok;
  int i, j;
  char *cb;
  int argc;
  char argvar[2000];
  char *argv[20];

  for (i=0;i<20;i++)
    argv[i] = argvar + i*100;
  for (i=0;i<MAXCLIENTS;i++)
    clients[i].st = NO_CLIENT;
  FD_ZERO (&allfds);

  FD_SET (socket,&allfds);
  numfds = socket+1;
  signal (SIGPIPE,SIG_IGN);
  while (1) {
    readfds = allfds;
    /*    printf ("readfds = %08x.\n",readfds.fds_bits[0]); */
    if (select (numfds,&readfds,NULL,NULL,NULL) < 0) {
      if (errno == EINTR) continue;
      perror ("Select failed");
      exit (1);
    }
    /*     printf ("Select returned. readfds = %08x.\n",readfds.fds_bits[0]);  */
    /* Check for new clients: Socket is read-able */
    if (FD_ISSET (socket,&readfds)) {
      int newplayer;
      FILE *newplayerFILE;

      sa = sizeof (remoteaddr);

      if ((newplayer = accept (socket,&remoteaddr,&sa)) < 0 ) 
	fatal ("%s: accept failed", myname);

      if ((newplayerFILE = fdopen (newplayer,"r+")) == NULL)
	fatal ("%s: fdopen", myname);

      for (curclient=0;curclient<MAXCLIENTS;curclient++)
	if (clients[curclient].st  == NO_CLIENT) break;
      if (curclient < MAXCLIENTS) {
	client = &clients[curclient]; 
	newclient (client,newplayer,newplayerFILE);
      } else {
	printf ("Max number of clients reached.\n");
	fprintf (newplayerFILE , "400 Sorry, Max number of clients (%d) reached.\n",MAXCLIENTS);
	fclose (newplayerFILE);
      }
      printf ("Ok. New player on fd = %d is welcome....\n",newplayer);
      continue;
    }
    /* check if a client did something... */
    for (curclient=0;curclient<MAXCLIENTS;curclient++) {
      client = & clients[curclient];
      if ((client->st != NO_CLIENT) && 
	  (FD_ISSET (client->fd,&readfds))) {
	do {
	  cb = read_a_line (curfd);
	  if (ral_eof (curfd)) {
	    printf ("Client %d didn't say goodbye :-( \n",curclient);
	    quit (0, argv);
	    break;
	  }
	  if (!cb) break;
	  /* 	    printf ("client %d typed '%s'\n", curclient, cb);   */
	  argc = sscanf (cb,"%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s",
			 argv[ 0],argv[ 1],argv[ 2],argv[ 3],
			 argv[ 4],argv[ 5],argv[ 6],argv[ 7],
			 argv[ 8],argv[ 9],argv[10],argv[11],
			 argv[12],argv[13],argv[14],argv[15]);
	  /*	    printf ("That's %d words.\n",argc); */
	  printf ("Client %d: ", curclient);
	  for (i=0;i<argc;i++)
	    printf ("%s ", argv[i]);
	  printf ("\n");
	  if (argc < 1) continue;
	  ok = 0;
	  for (j=0;j<nbuiltins;j++) {
	    if (strcmp (argv[0],builtins[j].name) == 0) {
	      (builtins[j].func) (argc,argv);
	      ok++;
	    }
	  }
	  if (!ok)
	    cprintf ("500 Invalid command\n");
	  fflush (curfp);
	} while (more_input_available (curfd));
      }
    }
  }
}


struct clientstr *getplayer (int pln)
{
  int i;

  for (i=0;i<MAXCLIENTS;i++)
    if ((clients[i].st != NO_CLIENT) &&
	(clients[i].pln == pln))
      return &clients[i];
  return (NULL);
}	


void newclient (struct clientstr *client,int newplayer, FILE *newplayerFILE)
{
  client->fd = newplayer;
  client->fp = newplayerFILE;

  FD_SET (curfd,&allfds);
  if ((curfd + 1)  > numfds) 
    numfds = curfd + 1;
  client->pln = NO_PLN;
  client->st = INITIALIZING;
  cprintf ("100 Hello. Atlantis server version %d.%d.%d ready.\n",
	   major, minor, subminor);
}





