/*
 *
 *      socketstuff.c 
 *
 *      By Roger E. Wolff (R.E.Wolff@BitWizard.nl).
 *
 *      Rev 2.0.
 *            Deleted lots of unneccesary code. Fits on a page now.
 */


#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>
#include <string.h>
#include "fatal.h"


/* Some manuals state that 5 is max. Some implementations might
 * support more */
#define BACKLOG 10

const char *myname;


int initsocket (u_short port)
{
  int socketfd; /* filedescriptors */
  struct sockaddr_in localaddress;
  int allow_reuse=1;

  memset (&localaddress, 0, sizeof (struct sockaddr_in));
  localaddress.sin_family = AF_INET;
  localaddress.sin_port = htons (port);

  if ((socketfd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
    fatal ("%s: socket", myname);


  if (setsockopt(socketfd, SOL_SOCKET, SO_REUSEADDR, &allow_reuse, 
		 sizeof allow_reuse) < 0)
    fatal ("%s: setsockopt", myname);

  if(bind(socketfd,(struct sockaddr *) &localaddress,
	  sizeof localaddress) < 0)
    fatal ("%s: bind", myname);

  if (listen(socketfd, BACKLOG) < 0)
    fatal ("%s: listen", myname);

  return (socketfd) ;
} /* end main */
